#!/usr/bin/python

import sys,struct

def named(tuple,names):
  return dict(zip(names.split(),tuple))
def consume(fmt,data,names):
  n = struct.calcsize(fmt)
  return named(struct.unpack(fmt,data[:n]),names),data[n:]
def cstring(string):
  return string.split('\0',1)[0]

def parse(file):
  print 'File: "%s"' % file
  data = open(file,'rb').read()
  prefix, data = consume('<5sBIB',data,'signature version size targets')
  print '%(signature)s v%(version)d, image size: %(size)d, targets: %(targets)d' % prefix
  for t in range(prefix['targets']):
    tprefix, data  = consume('<6sBI255s2I',data,'signature altsetting named name size elements')
    tprefix['num'] = t
    if tprefix['named']:
      tprefix['name'] = cstring(tprefix['name'])
    else:
      tprefix['name'] = ''
    print '%(signature)s %(num)d, alt setting: %(altsetting)s, name: "%(name)s", size: %(size)d, elements: %(elements)d' % tprefix
    tsize = tprefix['size']
    target, data = data[:tsize], data[tsize:]
    for e in range(tprefix['elements']):
      eprefix, target = consume('<2I',target,'address size')
      eprefix['num'] = e
      print '%(num)d, address: 0x%(address)08x, size: %(size)d' % eprefix
      esize = eprefix['size']
      image, target = target[:esize], target[esize:]
      #TODO: dump image???
    if len(target):
      print "target %d: parse error" % t
  suffix = named(struct.unpack('<4H3sBI',data[:16]),'device product vendor dfu ufd len crc')
  print 'usb: %(vendor)04x:%(product)04x, device: 0x%(device)04x, dfu: 0x%(dfu)04x, %(ufd)s, %(len)d, 0x%(crc)08x' % suffix
  data = data[16:]
  if data:
    print "parse error"
  print ""

if __name__=="__main__":
  f = sys.argv[1]
  parse(f)
